#!-----------------------------------------------------------------------------
#!
#! Debug tools version 1.00, created by Roel S.F. Abspoel (R.Abspoel@wkm.nl)
#! Feel free to use, however if you modify it let me know and send me a copy.
#!
#!-----------------------------------------------------------------------------
#TEMPLATE (DebugTools, 'Debug options'),FAMILY('ABC'),FAMILY('CW20')
#EXTENSION (Global_Debug, 'DebugTools - Global Extension'), APPLICATION
#SHEET
#TAB ('DebugTools')
#DISPLAY ('')
#DISPLAY ('This toolkit contains debug functions')
#DISPLAY ('for use within Clarion 5.5')
#DISPLAY ('')
#DISPLAY ('With this extenstion added you have')
#DISPLAY ('the following procedures:')
#DISPLAY ('')
#DISPLAY ('DebugInfo(Your debug message)')
#DISPLAY ('This option sends a string to the debugger')
#DISPLAY ('')
#DISPLAY ('DebugAppInfo()')
#DISPLAY ('This option sends info about the compiled')
#DISPLAY ('application to the debugger')
#DISPLAY ('')
#DISPLAY ('DebugGlobalVars()')
#DISPLAY ('This option sends info on the global vars')
#DISPLAY ('to the debugger')
#DISPLAY ('')
#DISPLAY ('The debugger used can be freely downloaded')
#DISPLAY ('http://www.sysinternals.com/')
#DISPLAY ('')
#DISPLAY ('Add the local extension to (optionaly) send')
#DISPLAY ('automatic debuginfo on local vars.')
#DISPLAY ('Or use DebugLocalVars() to retrieve them')
#DISPLAY ('manualy.')
#DISPLAY ('')
#DISPLAY ('Version 1.00 Copyright  Roel S.F. Abspoel')
#DISPLAY ('r.abspoel@wkm.nl')
#ENDTAB
#ENDSHEET
#AT (%GlobalMap)
  !--> Added by DebugTools
  DebugInfo(STRING)
  DebugAppInfo()
  DebugGlobalVars()
  MODULE('ImpShell2')
    SendToDebug(*CSTRING),RAW,PASCAL,NAME('OutputDebugStringA')
    VerQueryValue(Long,Long,Long,Long),Bool,Raw,Pascal,Name('VerQueryValueA')
  END
  !--> End of Add
#ENDAT
#AT (%ProgramProcedures)

!--> Added by DebugTools
DebugInfo Procedure(DebugString)
DebugCString    CSTRING(256)
  CODE
  DebugCString=DebugString
  SendToDebug(DebugCString)
  RETURN
  
DebugAppInfo Procedure()
    CODE
    DebugInfo('----------------> APPLICATION INFORMATION')
    DebugInfo('Informatie created on:'& FORMAT(TODAY(),@D4) & FORMAT(CLOCK(),@T6))
    DebugInfo('Application name: %Application ')
    #IF (%ApplicationDebug = %True)
      DebugInfo('Compiled in DEBUG mode.')
    #ENDIF
    #IF (%ApplicationLocalLibrary = %TRUE)
      DebugInfo('Compiled with local Runtime librarys')
    #ENDIF
    #FOR(%ApplicationTemplate)
      DebugInfo('Global templates: %ApplicationTemplate ')
    #ENDFOR
    #IF (%Target32 = %True)
      DebugInfo('32 bits Application.')
    #ELSE
      DebugInfo('16 bits Application.')
    #END
    DebugInfo('First procedure: %FirstProcedure')
    DebugInfo('App Type: %ProgramExtension')
    DebugInfo('Dictionary name: %DictionaryFile')
    DebugInfo('----------------> ')
    DebugInfo('Installation path:'& LONGPATH(PATH()))
    DebugInfo('----------------> ')
    RETURN
  
DebugGlobalVars     PROCEDURE()
      CODE
      #DECLARE (%Prefix)
      #DECLARE (%VarName)
      #DECLARE (%PrefixStart)
      #DECLARE (%PrefixEnd)
      DebugInfo('--------------> GLOBALE VARIABELEN')
      #FOR(%GlobalData)    
        #IF (INSTRING('QUEUE',%GlobalDataStatement,1,1) OR INSTRING('GROUP',%GlobalDataStatement,1,1))
          #SET(%PrefixStart,INSTRING('PRE(',%GlobalDataStatement,1,1)+4)
          #SET(%PrefixEnd  ,INSTRING(')',%GlobalDataStatement,1,%PrefixStart))
          #IF (%PrefixStart)   
            #SET(%Prefix,SUB(%GlobalDataStatement,%PrefixStart,%PrefixEnd-%PrefixStart) &':') 
            #IF (LEN(%Prefix) = 1)
          #SET(%Prefix,'')
            #ENDIF
          #ENDIF
            DebugInfo('From a queue or group only the active record is displayed.')
            DebugInfo('Global data: %[20]GlobalData %[15]GlobalDataStatement')
        #ELSE
          #IF (INSTRING('END',%GlobalDataStatement,1,1) OR INSTRING('FILE',%GlobalDataStatement,1,1))
            #SET (%Prefix,'')
            DebugInfo('Global data: %[20]GlobalData %[15]GlobalDataStatement')
          #ELSE  
            DebugInfo('Global data: %[20]GlobalData %[15]GlobalDataStatement Value: '& %Prefix%globalData)
          #ENDIF  
        #ENDIF
        #ENDFOR
        DebugInfo('-------------->')
      RETURN
      !--> End of Add
      
#ENDAT
#EXTENSION(Local_Debug,'Send Debuginformation to DebugVieuw'),PROCEDURE
#!-----------------------------------------------------------------------
! [PROCEDURE]
! NAME Main
#!
#!-----------------------------------------------------------------------------
#SHEET
#TAB ('Procedure DebugInfo')
#DISPLAY ('')
#DISPLAY ('This extension sends info to the debugger.')
#DISPLAY ('')
#DISPLAY ('')
#DISPLAY ('Information is send about:')
#DISPLAY ('Start / stop of the procedure')
#DISPLAY ('If procedure is a form then request type.')
#DISPLAY ('Locale extensions / templates')
#DISPLAY ('')
#DISPLAY ('The routine DebugLocalVars can send info ')
#DISPLAY ('about local variables and their values.')
#DISPLAY ('')
#PROMPT ('Auto debug local variables', CHECK), %AutoDebugLocalVars , AT(10)
#DISPLAY ('')
#DISPLAY ('Versie 1.00 Copyright  Roel S.F. Abspoel')
#DISPLAY ('R.Abspoel@wkm.nl')
#ENDTAB
#ENDSHEET
#AT(%WindowEventHandling,'OpenWindow'),PRIORITY(5000)
#!-----------------------------------------------------------------------------
      !--> Added by DebugTools
      DebugInfo('-----------------------------')
      DebugInfo('The procedure: %Procedure started.')
      CASE SELF.Request
      OF InsertRecord
        DebugInfo('Procedure Request: Add Record')
      OF ChangeRecord
        DebugInfo('Procedure Request: Change Record')
      OF DeleteRecord
        DebugInfo('Procedure Request: Delete Record')
      OF SelectRecord        
        DebugInfo('Procedure Request: Select Record')
      END
      DebugInfo('>-- LOCALE TEMPLATES')
      #FOR(%ActiveTemplate)
      DebugInfo('Active templates: %ActiveTemplate %ActiveTemplateType ')
      #ENDFOR
      #IF (%AutoDebugLocalVars)
        !--> Added by DebugTools
        DebugInfo('EVENT:OpenWindow posted, DebugLocalVars triggered')
        DO DebugLocalVars
        !--> End of Add
      #ENDIF
      !--> End of Add
      #ENDAT
      #!
      #!-----------------------------------------------------------------------------
      #AT(%WindowEventHandling,'CloseWindow'),PRIORITY(5000)
      #!-----------------------------------------------------------------------------
      #IF (%AutoDebugLocalVars)
        !--> Added by DebugTools
        DebugInfo('EVENT:CloseWindow posted, DebugLocalVars triggered')
        DO DebugLocalVars
        !--> End of Add
      #ENDIF
      !--> Added by DebugTools
      DebugInfo('De procedure: %Procedure was closed')
      DebugInfo('-----------------------------')
      !--> End of Add
      #ENDAT
      #!
      #!-----------------------------------------------------------------------------
      #AT(%ToolbarMethodCodeSection,'TakeEvent','(<<*LONG VCR>,WindowManager WM)'),PRIORITY(5001)
      #!-----------------------------------------------------------------------------
      #IF (%AutoDebugLocalVars)
        !--> Added by DebugTools
        CASE EVENT()
        OF 1
          EVENTNAME" = 'EVENT:Accepted'
        OF 2
          EVENTNAME" = 'EVENT:NewSelection'
        OF 3
          EVENTNAME" = 'EVENT:ScrollUp' 
        OF 4
          EVENTNAME" = 'EVENT:ScrollDown' 
        OF 5
          EVENTNAME" = 'EVENT:PageUp'
        OF 6
          EVENTNAME" = 'EVENT:PageDown'
        OF 7
          EVENTNAME" = 'EVENT:ScrollTop'
        OF 8
          EVENTNAME" = 'EVENT:ScrollBottom'
        OF 9
         EVENTNAME" = 'EVENT:Locate'
        END
        DebugInfo(CLIP(EVENTNAME") & ' posted, DebugLocalVars triggered')
        DO DebugLocalVars
        !--> End of Add
      #ENDIF
      #ENDAT
#!-----------------------------------------------------------------------------
#AT(%ProcedureRoutines),PRIORITY(4000)
#!-----------------------------------------------------------------------------
!--> Added by DebugTools
DebugLocalVars        ROUTINE
          #DECLARE (%LPrefix)
          #DECLARE (%LVarName)
          #DECLARE (%LPrefixStart)
          #DECLARE (%LPrefixEnd)
          DebugInfo('--------------> LOCAL VARS FROM: %Procedure')
          #FOR(%LocalData)    
            #IF (INSTRING('QUEUE',%LocalDataStatement,1,1) OR INSTRING('GROUP',%LocalDataStatement,1,1))
              #SET(%LPrefixStart,INSTRING('PRE(',%LocalDataStatement,1,1)+4)
              #SET(%LPrefixEnd  ,INSTRING(')',%LocalDataStatement,1,%LPrefixStart))
              #IF (%LPrefixStart)   
                #SET(%LPrefix,SUB(%LocalDataStatement,%LPrefixStart,%LPrefixEnd-%LPrefixStart) &':') 
                #IF (LEN(%LPrefix) = 1)
                  #SET(%LPrefix,'')
                #ENDIF
              #ENDIF
                DebugInfo('From a queue or group only the active record is displayed.')       
                DebugInfo('%[20]LocalData %[15]LocalDataStatement')
            #ELSE
              #IF (INSTRING('END',%LocalDataStatement,1,1) OR INSTRING('FILE',%LocalDataStatement,1,1))
                #SET (%LPrefix,'')
                DebugInfo('%[20]LocalData %[15]LocalDataStatement')
              #ELSE
                DebugInfo('%[20]LocalData %[15]LocalDataStatement Value:'& %LPrefix%LocalData)
              #ENDIF  
            #ENDIF
            #ENDFOR
            DebugInfo('-------------->')
            EXIT
            !--> End of Add  
#ENDAT